"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = compileRoutes;

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _flattenRoutes = _interopRequireDefault(require("./flattenRoutes"));

var _normalizePage = _interopRequireDefault(require("./normalizePage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Given some route configuration, prepare them for use.
 */
function compileRoutes(routes) {
  return (0, _flattenRoutes.default)(routes).map(function (route) {
    var keys = [];
    var matchPath = (0, _pathToRegexp.default)(route.path, keys);

    var toPath = _pathToRegexp.default.compile(route.path);

    var keyNames = keys.map(function (key) {
      return key.name;
    });
    return _objectSpread({}, route, {
      page: (0, _normalizePage.default)(route.page),
      matchPath: matchPath,
      toPath: toPath,
      keyNames: keyNames,
      allKeyNames: [].concat(_toConsumableArray(keyNames), _toConsumableArray(Object.keys(route.params || [])))
    });
  });
}